package djmil.cordacheckers.contracts;

import java.util.List;

import net.corda.v5.base.exceptions.CordaRuntimeException;
import net.corda.v5.ledger.utxo.Command;

public class GameBoardCommand implements Command {
    public static enum Type {
        SURRENDER,
        DRAW,
        VICTORY,
        MOVE;
    }

    private final Type type;
    private final List<Integer> move; // [0] from, [1] to

    public GameBoardCommand(Type type) {
        if (type == Type.MOVE)
            throw new CordaRuntimeException (BAD_ACTIONMOVE_CONSTRUCTOR);

        this.type = type;
        this.move = null;
    }

    public GameBoardCommand(List<Integer> move) {
        this.type = Type.MOVE;
        this.move = move;
    }

    public Type getType() {
        return this.type;
    }

    public List<Integer> getMove() {
        if (type != Type.MOVE)
            throw new CordaRuntimeException (NO_MOVES_FOR_ACTIONTYPE +type);

        return this.move;
    }

    static final String BAD_ACTIONMOVE_CONSTRUCTOR = "Bad constructor for Action.MOVE";
    static final String NO_MOVES_FOR_ACTIONTYPE = ".getMove() not possible for ";
}
