package djmil.cordacheckers;

import net.corda.v5.application.marshalling.JsonMarshallingService;
import net.corda.v5.crypto.SecureHash;

public class FlowResult {
    public final Object successStatus;
    public final String transactionId;
    public final String failureStatus;

    public FlowResult(Object success) {
        this.successStatus = success;
        this.transactionId = null;
        this.failureStatus = null;
    }

    public FlowResult(Object success, SecureHash transactionId) {
        this.successStatus = success;
        this.transactionId = transactionId.toString();
        this.failureStatus = null;
    }

    public FlowResult(Exception exception) {
        this.successStatus = null;
        this.transactionId = null;
        this.failureStatus = exception.getMessage();
    }

    public String toJsonEncodedString(JsonMarshallingService jsonMarshallingService) {
        return jsonMarshallingService.format(this);
    }
    
}